package fishrungames.bashgid;


import fishrungames.bashgid.core.VideoManager;
import fishrungames.bashgid.core.VideoManager.VideoRecordData;
import fishrungames.networkutils.ImageManager;

import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;


public class VideoRecordFragment extends Fragment
{
	
	String videoUrl;
	
	VideoRecordData recordData;
	
	public VideoRecordFragment()
	{
		this.videoUrl = "";
		this.recordData = null;
	}
	
	public VideoRecordFragment(String videoUrl)
	{
		this.videoUrl = videoUrl;
		RestoreVideo();
	}
	
	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		View rootView = inflater.inflate(R.layout.fragment_video_record_page, container, false);
		
		TextView nameTextView = (TextView) rootView.findViewById(R.id.nameTextView);
		nameTextView.setText(recordData.title);
		
		TextView descriptionTextView = (TextView) rootView.findViewById(R.id.descriptionTextView);
		descriptionTextView.setText(recordData.description);
		
		ImageView imageView = (ImageView) rootView.findViewById(R.id.imageView);
		ImageManager.getInstance().ApplyImageToImageView(imageView, recordData.previewImageUrl);
		
		imageView.setOnClickListener(new OnClickListener()
		{

			@Override
			public void onClick(View v)
			{
				if (recordData.type == VideoManager.VIDEO_TYPE_YOUTUBE)
				{
					MainActivity.getInstance().startActivity(new Intent(Intent.ACTION_VIEW, Uri.parse(recordData.videoUrl)));
				}
			}
			
		});
		
		return rootView;
	}
	
	
	void RestoreVideo()
	{
		recordData = MainActivity.getInstance().videoDataSource.GetVideoByVideoUrl(videoUrl);
	}
	
}
