package fishrungames.bashgid.core;

import java.util.ArrayList;
import java.util.Collections;

import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import fishrungames.bashgid.MainActivity;
import fishrungames.bashgid.core.NewsManager.NewsRecord;
import fishrungames.bashgid.core.NewsManager.NewsSortComparator;
import fishrungames.networkutils.ImageDownloadTask;

public class NewsDownloadTask extends AsyncTask<Bundle, Integer, Long>
{

	public Handler mHandler;

	protected Long doInBackground(Bundle... queryArr)
	{

		ArrayList<NewsRecord> localNewsRecordArr = MainActivity.getInstance().newsDataSource.getNews();

		ArrayList<String> imageToDownloadList = new ArrayList<String>();

		for (int i = 0; i < NewsManager.urlArr.length; i++)
		{

			NewsManager.LoadNewsAndImagesFromRss2(NewsManager.urlArr[i], localNewsRecordArr, imageToDownloadList);

		}

		Collections.sort(localNewsRecordArr, new NewsSortComparator());

		NewsManager.getInstance().replaceNews(localNewsRecordArr);

		Bundle innerQuery = new Bundle();

		innerQuery.putStringArray("imageUrlArr", imageToDownloadList.toArray(new String[imageToDownloadList.size()]));

		ImageDownloadTask task = new ImageDownloadTask();

		task.mHandler = this.mHandler;

		task.execute(innerQuery);

		return (long) 0;
	}

	protected void onProgressUpdate(Integer... progress)
	{
		Message completeMessage = mHandler.obtainMessage(MainActivity.NEWS_DOWNLOADER_STATE_UPDATE, this);

		completeMessage.sendToTarget();

	}

	protected void onPostExecute(Long result)
	{
		Message completeMessage = mHandler.obtainMessage(MainActivity.NEWS_DOWNLOADER_STATE_FINISHED, this);

		completeMessage.sendToTarget();
	}

}
