package fishrungames.bashgid.core.db;


import fishrungames.bashgid.core.PhotoManager;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;

import android.database.sqlite.SQLiteDatabase;
import android.util.Log;

public class PhotoDataSource
{
	// private SQLiteDatabase database = null;

	private BashgidSqliteHelper dbHelper = null;

	// private String[] allColumns = { BashgidSqliteHelper.COLUMN_ID,
	// BashgidSqliteHelper.COLUMN_TITLE, BashgidSqliteHelper.COLUMN_DESCRIPTION,
	// BashgidSqliteHelper.COLUMN_IMAGE_URL, BashgidSqliteHelper.COLUMN_GEOLAT,
	// BashgidSqliteHelper.COLUMN_GEOLON };

	public PhotoDataSource(Context context, BashgidSqliteHelper dbHelper)
	{

		this.dbHelper = dbHelper;

	}

	public void AddOrReplacePhoto(PhotoManager.PhotoRecordData recordData)
	{
		SQLiteDatabase database = dbHelper.getWritableDatabase();

		if (database != null)
		{
			try
			{
				ContentValues values = new ContentValues();

				//values.put(BashgidSqliteHelper.COLUMN_ID, 1);
				values.put(BashgidSqliteHelper.COLUMN_TITLE, recordData.title);
				values.put(BashgidSqliteHelper.COLUMN_DESCRIPTION, recordData.description);
				values.put(BashgidSqliteHelper.COLUMN_IMAGE_URL, recordData.imageUrl);
				values.put(BashgidSqliteHelper.COLUMN_IMAGE_HASH, recordData.imageHash);
				values.put(BashgidSqliteHelper.COLUMN_GEOLAT, recordData.geoLat);
				values.put(BashgidSqliteHelper.COLUMN_GEOLON, recordData.geoLon);

				boolean r = isPhotoAlreadyExist(recordData.imageUrl, database);
				if (!r)
				{
					Log.e("a", "aaa1");
					database.insert(BashgidSqliteHelper.TABLE_PHOTO, null, values);
					Log.e("a", "aaa2");
				} else
				{
					// Replace
					Log.e("a", "aaa3");
				}

				Log.e("a", "aaa4");
			} finally
			{
				dbHelper.close();
			}
		}

	}
	
	public PhotoManager.PhotoRecordData GetPhotoByImageUrl(String imageUrl)
	{
		PhotoManager.PhotoRecordData result = null;
		
		SQLiteDatabase database = dbHelper.getWritableDatabase();

		if (database != null)
		{
			try
			{
				result = InnerGetPhotoByImageUrl(imageUrl, database);				
				
			} finally
			{
				dbHelper.close();
			}
		}

		return result;
	}
	
	public PhotoManager.PhotoRecordData InnerGetPhotoByImageUrl(String imageUrl, SQLiteDatabase database)
	{

				Cursor cursor = database.query(BashgidSqliteHelper.TABLE_PHOTO, 
						new String[] { BashgidSqliteHelper.COLUMN_TITLE, BashgidSqliteHelper.COLUMN_DESCRIPTION, BashgidSqliteHelper.COLUMN_IMAGE_URL, BashgidSqliteHelper.COLUMN_IMAGE_HASH, BashgidSqliteHelper.COLUMN_GEOLAT, BashgidSqliteHelper.COLUMN_GEOLON },
						BashgidSqliteHelper.COLUMN_IMAGE_URL + "=?", new String[] { imageUrl }, null, null, null, null);

				if (cursor != null)
				{
					if (cursor.getCount() > 0)
					{
						cursor.moveToFirst();
						
						return new PhotoManager.PhotoRecordData(
								cursor.getString(0),
								cursor.getString(1),
								cursor.getString(2),
								cursor.getString(3),
								cursor.getDouble(4),
								cursor.getDouble(5)
								);						
					}
				}
				
				return null;

	}

	private boolean isPhotoAlreadyExist(String imageUrl, SQLiteDatabase database)
	{
		Cursor cursor = database.query(BashgidSqliteHelper.TABLE_PHOTO, new String[] { BashgidSqliteHelper.COLUMN_IMAGE_URL },
				BashgidSqliteHelper.COLUMN_IMAGE_URL + "=?", new String[] { imageUrl }, null, null, null, null);

		if (cursor != null)
		{
			if (cursor.getCount() > 0)
			{
				return true;
			}
		}
		
		return false;
		

	}

}
